// This sourcefile is created by Peter Jodda / peter@jodda.de
// It is under the Peter Jodda license:
// Everyboy may use it on his own risk. This header must stay in the file!
// If you expand this file, please contact me, that I can integrate the
// enhancemants in the original file.
//

#include <qdialog.h>
#include <qpushbutton.h>
#include <qgrid.h>
#include <qlayout.h>
#include <qlabel.h>


#include <stdio.h>

#include "aboutbox.h"


//-----------------------------------------------------------------------------

AboutBox::AboutBox(QWidget *parent) : 
		QDialog(parent,"Settings",TRUE)
{
   QPushButton *ok;
   QGridLayout *grid;
   QBoxLayout  *topLayout;
   char        versionString[20];
   char        buildString[30];

   setCaption("About KHdRecord");

   topLayout = new QVBoxLayout( this, 2 );
   
   topLayout->addWidget(new QLabel(" ",this));
   topLayout->addWidget(new QLabel("KHdRecord",this),0,AlignHCenter);
   topLayout->addWidget(new QLabel(" ",this));

   sprintf(versionString,"%s",KHDRECORD_VERSION);
   sprintf(buildString  ,"%s",   __DATE__ );
   
   grid = new QGridLayout( topLayout, 2, 2,10);
   grid->addWidget(new QLabel("Version",this),0,0);
   grid->addWidget(new QLabel("Build on",this),1,0);
   grid->addWidget(new QLabel(versionString,this),0,1);
   grid->addWidget(new QLabel(buildString,this),1,1);


   topLayout->addWidget(new QLabel(" ",this));
   topLayout->addWidget(new QLabel("Solutions for a large Universe", this));
   topLayout->addWidget(new QLabel(" ",this));
   topLayout->addWidget(new QLabel("Peter Jodda / peter@jodda.de",this) ,0,AlignRight);
   topLayout->addWidget(new QLabel(" ",this)); 


   // --- the ok button
   ok = new QPushButton( "OK", this );
   //ok->setGeometry( 10,10, 100,30 );
   connect( ok, SIGNAL(clicked()), SLOT(accept()) );

   topLayout->addWidget(ok,20,AlignCenter);   
   

} // Aboutbox constructor

