#ifndef _AUDIORECORDER_CLASS_LOADED
#define _AUDIORECORDER_CLASS_LOADED 1

#ifdef HAS_ARTSD

#include <artsc/artsc.h>
#endif

#include "saveblock.h"

class AudioRecorder
{
public:

   AudioRecorder(const char * cp_DeviceName);
   ~AudioRecorder();

   int SetDevice(const char * cp_DeviceName);

   bool SetSpeed(int &speed);

   int ReadAudio();

   void SetSaveBlockArray(SaveBlockArray *pc_SaveBlockArray);
   
   int GetError();
   void Abort();

   // indicate, that the recorder should stop
   volatile bool StopRecording;

   private:
      bool SyncAudio();

      int m_i_AudioHandle;
      int i_AudioFormatMask;

      int i_Error;

      SaveBlockArray *pc_SaveBlockArray;

   char m_ca_DeviceName[100];

   bool m_b_ArtsdUsed;
#ifdef HAS_ARTSD
      arts_stream_t stream;
      int packetsize;
#endif

} ;  // AudioRecorder

#endif




