// basic definition
// needed for multiple modules

#ifndef _BASEDEF_LOADED
#define _BASEDEF_LOADED

#include <sys/ioctl.h>
#include <linux/soundcard.h>

//===========================================================================
//
// define some common used structures / enums
//

enum RecordMode
{
   ModeMp3 =1,
   ModeWave,
   ModeOgg   
};

enum FilenameChangeMode
{
   FilenameChange_StartWithBasename,
   FilenameChange_AlwaysIncrement,
   FilenameChange_UseDate
};



//===========================================================================
//
// state, describing, what the program is currently doing

class ProgramState
{
public:
   bool b_AnalyzeMode;
   bool b_TimerMode;
   bool b_TimedSplitMode;

   bool b_GlobalStop;
   bool b_Paused;
   bool b_TriggerSplitting;
   bool b_AnalyzeQuiet;
   // stop the timer thread when true.
   bool b_TimerStop;
   // status, whether controller thread is just recording
   bool b_ControllerIsRecording;
   bool b_TotalFileNameChanged;
   bool b_DeviceAvailable;
   bool b_CommandLineMode;
   bool b_ServerMode;
   bool b_RemoteMode;

   ProgramState()
   {
      b_AnalyzeMode =false;
      b_TimerMode   =false;
      b_TimedSplitMode = false;

      b_GlobalStop =false;
      b_Paused     = false;
      b_TriggerSplitting = false;
      b_AnalyzeQuiet = false;
      // stop the timer thread when true.
      b_TimerStop = false;
      // status, whether controller thread is just recording
      b_ControllerIsRecording = false;
      b_TotalFileNameChanged = false;
      b_DeviceAvailable = false;
      b_CommandLineMode = false;
      b_ServerMode = false;
      b_RemoteMode = false;
   }
} ;

#define DEFAULT_SERVER_PORT 0x2626

#endif  // _BASEDEF_LOADED





