#ifndef _COMMANDLINE_H_LOADED
#define _COMMANDLINE_H_LOADED

#include <time.h>
#include <qstring.h>

#include "basedef.h"

enum ParameterResultType
{
   ParameterType_Empty,
   ParameterType_Integer,
   ParameterType_String,
   ParameterType_Time,
   ParameterType_Bool,
   ParameterType_RecordMode
} ;

class CommandLineParameter
{
public:
   CommandLineParameter(int argc, char *argv[]);
   ~CommandLineParameter();

   int m_i_InputLevel;
   int m_i_InputLevelMaster;
   int m_i_Bitrate;
   int m_i_ServerPort;
   int m_i_AnalyzeLevel;
   int m_i_AnalyzeTimeout;

   QString m_qs_Outputname;
   QString m_qs_InputDevice;
   int     m_i_InputDevice;
   QString m_qs_SoundDevice;
   QString m_qs_MixerDevice;
   QString m_qs_RecorderFile;
   RecordMode m_e_RecordMode;


   time_t  m_t_StartTime;
   time_t  m_t_StopTime;

   bool m_b_ParseOK;  
   bool m_b_TestMode;
   bool m_b_ServerMode;
   bool m_b_RemoteMode;
   bool m_b_AnalyzeMode;

   int ParseParameter(int argc, char *argv[]);
   int ParseASingleParameter( char *cp_Parameter);

   bool CheckParameter(QString qs_Parameter,
                            QString qs_StartChars,
                            ParameterResultType e_ResultType,
                            void *p_Result);

   void ShowError(QString qs_Command,
                  QString qs_RealParameter,
                  ParameterResultType e_ResultType
                 );
   bool CheckValidParameters();

}; // CommandLineParameter

#endif  // _COMMANDLINE_H_LOADED






