#ifndef _H_LEVELMETER_H
#define _H_LEVELMETER_H

#include <qapplication.h>

#include <qwidget.h>
#include <qimage.h>
#include <qfont.h>
#include <qcolor.h>
#include <qbrush.h>


// number of values in the level meter


#define LEVEL_METER_VALUES 20


class LevelMeter : public QWidget
{
   Q_OBJECT

   public:
   
   LevelMeter(QWidget *parent);
   ~LevelMeter();
   

   // set a new block of data values
   void SetValue(float f_Value);

   public:
      void  paintEvent(QPaintEvent *theEvent);
      void  resizeEvent(QResizeEvent *theEvent);
      void  mousePressEvent(QMouseEvent *theEvent);

   
   private:
      // dimension of this area
      int i_Width;
      int i_Height;
      
      // pre allocated brush and colors, for faster drawings
      QBrush   *pc_Brush;
      QColor   *pc_BlackColor;
      QColor   *pc_GreenColor;
      QColor   *pc_YellowColor;
      QColor   *pc_RedColor;
      
      
      // is the sample output stopped?
      bool b_Stopped;
      float m_f_Level;
   
};


#endif  // LEVEL_METER



