// record description
#ifndef _RECDESCR_LOADED
#define _RECDESCR_LOADED

#include <time.h>
#include <qlist.h>
#include <qstring.h>
#include <stdio.h>


#include "basedef.h"

class RecordDescription
{

public:

   RecordDescription();
   RecordDescription(RecordDescription &ExistingOne);
   ~RecordDescription();
   

   time_t m_t_StartTime;
   time_t m_t_EndTime;
   
   RecordMode m_e_RecordingFormat;
   
   int   m_i_RecordingLevel;
   int   m_i_RecordingLevelMaster;
   int   m_i_MP3Rate;
   int   m_i_InputDevice;
   
   bool  m_b_UseAnalyzeMode;
   
   QString m_qs_Description;
   

   bool OverlapsWith(RecordDescription & c_OtherRecord);   
   void MergeRecords(RecordDescription & c_OtherRecord);
   
   int SaveToFile(FILE *fp_Outfile);
   int LoadFromFile(FILE *fp_Infile);

} ; // class RecordDescription


class RecordDescriptionList
{

public:
    QList<RecordDescription > m_List;
   RecordDescriptionList();
   ~RecordDescriptionList();   

   int ReadFromFile(FILE *fp_Infile);
   int ReadFromFile(QString qs_Filename);
   int WriteToFile (FILE *fp_Outfile);

   void AddRecord(RecordDescription *pc_Description);
   void MergeRecord(RecordDescription *pc_Description);
   void DeleteRecord(int i_Number);
   void DeleteAll();
   void DeleteOldTimes();
   int  GetCount();
   RecordDescription *GetRecord(int i_Number);
   
   bool HasOverlappingTime(RecordDescription *pc_NewRecord,
   			int i_ExistingRecordIndex);
   			
   bool TestForOverlappingTime( RecordDescription *pc_NewRecord);  			

   void CreateTestDataset();

};

#endif // _RECDESCR_LOADED


