#ifndef _RECORDLISTBOX_H
#define _RECORDLISTBOX_H

#include <qapplication.h>

#include <qdialog.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qcombobox.h>
#include <qslider.h>
#include <qlabel.h>
#include <qcolor.h>
#include <qlistbox.h>
#include "recdescr.h"
#include <qdatetimeedit.h>


class HdRecord;


class RecordListBox : public QDialog
{
  Q_OBJECT
public:
   RecordListBox(QWidget *parent=0,
               HdRecord *theApplication=NULL);

private:
	HdRecord *p_TheApplication;

   QPushButton  *m_AddButton;
   QPushButton  *m_ChangeButton;
   QPushButton  *m_DeleteButton;
   QPushButton  *m_SaveButton;
   QPushButton  *m_LoadButton;
   QListBox     *m_ListBox;
   QDateTimeEdit *m_StartLineEdit;
   QDateTimeEdit *m_StopLineEdit;
   QComboBox    *m_RecordingTypeCombo;
   QComboBox    *m_MP3BitrateCombo;
   QComboBox    *m_InputDeviceCombo;
   QSlider      *m_SampleLevelSlider;
   QLabel       *m_SampleLevelLabel;
   QSlider      *m_SampleLevelMasterSlider;   
   QLabel       *m_SampleLevelMasterLabel;


   void SetDefaultValues();
   void SetSliderLevelLabel();
   void NextHour(struct tm *);
   
   void CopyRecordsIntoDisplayList();
   void SetDisplayValuesFromRecord(RecordDescription *pc_Record);
   void CopyDisplayValuesIntoRecord(RecordDescription *pc_Record);
   
   QString GetFilename(bool b_LoadFile = true);
   void    SetButtonSensitivity();
   
   void    RefreshDisplay();
   
   
   bool m_b_StartTimeValid;
   bool m_b_StopTimeValid;
   
   QColor m_DefaultBackgroundColor;
   QColor m_ErrorBackgroundColor;
   
   time_t m_t_Start;
   time_t m_t_Stop;
   
   int    m_i_CurrentSelected;
   int    m_i_DaylightSavingTimeActiv;

public slots:
   void ClosePressed();
   void DoLevelSliderValueChanged(int);


   void DoStartTimeChanged(const QDateTime &);
   void DoStopTimeChanged(const QDateTime &);
   void DoAddButtonPressed();
   void DoChangeButtonPressed();
   void DoDeleteButtonPressed();

   void DoSaveButtonPressed();
   void DoLoadButtonPressed();
   
   void ListBoxSelectionChanged();
   

}; // class RecordListBox

#endif // _RECORDLISTBOX_H
