#ifndef _H_SAMPLE_AREA_H
#define _H_SAMPLE_AREA_H

#include <qapplication.h>

#include <qwidget.h>
#include <qimage.h>
#include <qfont.h>
#include <qcolor.h>
#include <qbrush.h>

#include "saveblock.h"

// number of values in the sample area


#define SAMPLE_AREA_VALUES 256


class SampleArea : public QWidget
{
   Q_OBJECT

   public:
   
   SampleArea(QWidget *parent);
   ~SampleArea();
   

   // set a new block of data values
   void SetValues(unsigned short *p_Values);

   public:
      void  paintEvent(QPaintEvent *theEvent);
      void  resizeEvent(QResizeEvent *theEvent);
      void  mousePressEvent(QMouseEvent *theEvent);

   
   private:
      // dimension of this area
      int i_Width;
      int i_Height;
      
      // pre allocated brush and colors, for faster drawings
      QBrush   *pc_Brush;
      QColor   *pc_WhiteColor;
      QColor   *pc_BlackColor;
      
      // current state of the sample area
      unsigned short us_Values[SAMPLE_AREA_VALUES];
      
      // is the sample output stopped?
      bool b_Stopped;
   
};


#endif



