#ifndef _SAVEBLOCK_CLASS_LOADED
#define _SAVEBLOCK_CLASS_LOADED 1

#include <string.h>
#include <semaphore.h>


class SaveBlock
{
public:
	unsigned char *Buffer;
	size_t         BufferSize;
	size_t         BufferFilled;
	unsigned char *BufferSavePosition;
	bool           b_FinalBlock;
	int            m_i_Level;
	int            m_i_AnalyzeResult;


	SaveBlock(size_t size);
	~SaveBlock();
	
	int WriteBlock(int OutFileHandle);
	bool IsFinalBlock();
	void SetFinalBlock();

	bool Analyze( int schwelle, float &f_Level);

} ; // SaveBlock



// number of saved blocks
#define SAVEBLOCKARRAYSIZE 12

// byte size of a saveblocks
#define SAVEBLOCKBUFFERSIZE 0x10000



class SaveBlockArray
{
public:
   
   SaveBlockArray();
   ~SaveBlockArray();
   
   SaveBlock *GetNextRecordBlock();
   SaveBlock *GetNextWriteBlock();
   void ReleaseRecordBlock();
   
private:
   int NextRecordBlock;
   int NextWriteBlock;

   sem_t BufferSemaphore;


   SaveBlock *pc_SaveBlocks[SAVEBLOCKARRAYSIZE];
}; // SaveBlockArray

#endif // _SAVEBLOCK_CLASS_LOADED



